/*
 * Crash Course STM32C0
 * Elektronika Praktyczna
 * 
 * Przyklad 1. Dzien dobry w jezyku MCU, czyli Blinky na STM32C0
 * plik main.c
 *
 */

#include "stm32c031xx.h"

void delayMilisec(uint32_t n);

int main()
{

	/* wlaczenie taktowania bloków GPIO */
	RCC->IOPENR |= RCC_IOPENR_GPIOAEN
				| RCC_IOPENR_GPIOBEN
				| RCC_IOPENR_GPIOCEN
				| RCC_IOPENR_GPIODEN;

	/* wyzerowanie bitow konfig. linii PA5 */
	GPIOA->MODER &= ~GPIO_MODER_MODE5;

	/* ustawienie PA5 jako wyjscie */
	GPIOA->MODER |= GPIO_MODER_MODE5_0;

	while(1)
	{
		/* stan wysoki na PA5 */
		GPIOA->BSRR = GPIO_BSRR_BS5;

		delayMilisec(100);

		/* stan niski na PA5 */
		GPIOA->BSRR = GPIO_BSRR_BR5;

		delayMilisec(100);

	}
}


void delayMilisec(uint32_t n){

	for(uint32_t i = 0; i < 400*n; i++)
	{
		__NOP();
		__NOP();
		__NOP();
		__NOP();
		__NOP();
		__NOP();
		__NOP();
		__NOP();
		__NOP();
		__NOP();
	}

}


