/*
 *  Crash Course STM32C0
 *  Elektronika Praktyczna
 *
 *  Przyklad 5. Obsluga wyjscia PWM
 * 	plik hardware.c
 *
 */


#include "hardware.h"


void RCC_configClockSource(void)
{

	uint16_t i = 0;

	/* wlaczenie oscylatora HSE */
	RCC->CR |= RCC_CR_HSEON;

	while(i < 1000)
	{

		i++;

		/* test flagi gotowosci HSE */
		if((RCC->CR & RCC_CR_HSERDY) == RCC_CR_HSERDY)
			break;

	}

	if(i < 1000)
	{

		/* preskaler HCLK = 2 => HCLK = SYSCLK/2 = 24 MHz */
		RCC->CFGR |= RCC_CFGR_HPRE_3;

		/* preskaler PCLK = 2 => PCLK = HCLK/2 = 12 MHz */
		RCC->CFGR |= RCC_CFGR_PPRE_2;

        /* zrodlo sygnalu dla SYSCLK: HSE */
        RCC->CFGR |= RCC_CFGR_SW_0;

        /* sprawdzenie czy SYSCLK przelaczyl sie na HSE */
        while(i < 10)
        {

        /* test flagi gotowosci HSE */
        if((RCC->CFGR & RCC_CFGR_SWS_0) == RCC_CFGR_SWS_0)
           	break;

        i++;

    }

    /* miejsce na obsluge bledu SWS */
    if(i == 10)
		
        while(1);

    } else {

        /* miejsce na obsluge bledu uruchomienia HSE */
        while(1);

    }

}

void GPIO_config(void)
{

	/* wlaczenie taktowania blokow GPIO */
    RCC->IOPENR |= RCC_IOPENR_GPIOAEN
            | RCC_IOPENR_GPIOBEN
            | RCC_IOPENR_GPIOCEN
            | RCC_IOPENR_GPIODEN;


    /* ustawienie linii 5 jako AF5 */
    GPIOA->MODER &= ~GPIO_MODER_MODE5;
    GPIOA->MODER |= GPIO_MODER_MODE5_1;
    GPIOA->AFR[0] |= GPIO_AFRL_AFSEL5_2 | GPIO_AFRL_AFSEL5_0;

}


void PWM_config(void)
{

	/* wlaczenie taktowania dla TIM1 */
	RCC->APBENR2 |= RCC_APBENR2_TIM1EN;

	/* preskaler = 239 */
	TIM1->PSC |= 2 * PCLK_FREQ / ( PWM_FREQ *  PWM_RES )  - 1;

	/* ustawienie wartosci automatycznego przeladowania licznika */
	TIM1->ARR = PWM_RES - 1;

	/* startujemy z wypelnieniem = 0 */
	TIM1->CCR1 = 0;

	/* PWM tryb 1 - wyjscie aktywne jezeli licznik < CCR1 */
	TIM1->CCMR1 |= TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1;

	/* wlaczenie funkcji pre-ladowania rejestru CCR1 */
	TIM1->CCMR1 |= TIM_CCMR1_OC1PE;

	/* wlaczenie kanalu 1 */
	TIM1->CCER |= TIM_CCER_CC1E;

	/* Main Output Enable - globalne zezwolenie na generowanie sygnalow PWM */
	TIM1->BDTR |= TIM_BDTR_MOE;

	/* wlaczenie timera */
	TIM1->CR1 |= TIM_CR1_CEN;

	/* wymuszenie wstepnego przeladowania rejestrow timera */
	TIM1->EGR |= TIM_EGR_UG;

}

void PWM_set_duty(uint8_t pwm)
{
	/* zmiana rejestru porownywanego z wartoscia licznika */
	TIM1->CCR1 = pwm;
}


