/*
 * Crash Course STM32C0
 * Elektronika Praktyczna
 *
 * Przyklad 6. Komunikacja przez SPI
 * plik main.c
 *
 */

#include "stm32c031xx.h"
#include "hardware.h"
#include "utils.h"
#include "lis2dw12_driver.h"


int main()
{

    GPIO_config();
    RCC_configClockSource();
    UART_config();
    
    /* inicjalizacja SPI */
    SPI_config();

	/* ustawienie rejestrow akcelerometru */
    LIS2DW12_startup();


    while(1)
    {

		/* polling bitu DRDY w oczekiwaniu na nowe dane */
    	if(LIS2DW12_check_DRDY())
    	{
    		int16_t x, y, z;
    		char delim[] = ",";
    		char eol[] = "\n";

			/* odczyt zestawu szesciu rejestrow wyjsciowych */
    		LIS2DW12_read_XYZ(&x, &y, &z);
    		
    		
    		/* przygotowanie stringow do wysylki i nadanie przez UART */
    		UART_print_num(x);
    		UART_print_chars(delim);

    		UART_print_num(y);
    		UART_print_chars(delim);

    		UART_print_num(z);
    		UART_print_chars(eol);
    	}

    }
}







