/*
 * Crash Course STM32C0
 * Elektronika Praktyczna
 *
 * Przyklad 7. Komunikacja przez SPI + NVIC + EXTI
 * plik main.c
 */

#include "stm32c031xx.h"
#include "hardware.h"
#include "utils.h"
#include "lis2dw12_driver.h"


volatile uint8_t drdy_flag;

int main()
{

    GPIO_config();
    RCC_configClockSource();
    UART_config();
    SPI_config();

    LIS2DW12_startup();
    
    /* konfiguracja linii przerwan INT1 */
    LIS2DW12_enable_DRDY_INT1();

	/* inicjalizacja EXTI */
    EXTI_config();
    
    /* konfiguracja NVIC, wlaczenie przerwan */
    NVIC_Config();

    while(1)
    {

    	if(drdy_flag)
    	{
    		drdy_flag = 0;

    		int16_t x, y, z;
    		char delim[] = ",";
    		char eol[] = "\n";

			/* odczyt rejestrow wyjsciowych */
    		LIS2DW12_read_XYZ(&x, &y, &z);
    		
    		/* pakowanie i wysylka danych na UART */
    		UART_print_num(x);
    		UART_print_chars(delim);

    		UART_print_num(y);
    		UART_print_chars(delim);

    		UART_print_num(z);
    		UART_print_chars(eol);
    	}

    }
}

