/*
 * Crash Course STM32C0
 * Elektronika Praktyczna
 *
 * Przyklad 8. Komunikacja przez I2C + NVIC + EXTI
 * plik lis2dw12_driver.c
 *
 */

#include "lis2dw12_driver.h"


void LIS2DW12_I2C_startup(void){

	uint8_t out[2], in[2];

	/* odczyt (R/W=1) rejestru WHO_AM_I (adres=0x0F) */
	I2C_read_bytes(0x0F, in, 1);

	/* ustawienie (R/W=0) rejestru CTRL1 (High Performance Mode, 14 bit/25 Hz) */
	out[0] = 0x20;
	out[1] = 0x34;
	I2C_write_bytes(out, 2);

	/* ustawienie rejestru CTRL6 (Low Noise) */
	out[0] = 0x25;
	out[1] = 0x04;
	I2C_write_bytes(out, 2);

}

void LIS2DW12_I2C_read_XYZ(int16_t *x, int16_t *y, int16_t *z){

	/* odczyt rejestrow wyjsciowych akcelerometru */
	/* poczawszy od adresu 0x28 */
	uint8_t in[6];

	I2C_read_bytes(0x28, in, 6);

	*x = (int16_t)(in[1] << 8) | in[0];
	*y = (int16_t)(in[3] << 8) | in[2];
	*z = (int16_t)(in[5] << 8) | in[4];

}


void LIS2DW12_I2C_enable_DRDY_INT1(void){

	uint8_t out[2];

   	/* zapis bitu INT1_DRDY(0x01) w rejestrze CTRL4_INT1_PAD_CTRL  (0x23) */
	out[0] = 0x23;
   	out[1] = 0x01;
   	I2C_write_bytes(out, 2);

   	/* zapis bitu INTERRUPTS_ENABLE(0x20) w rejestrze CTRL7(0x3F) */
	out[0] = 0x00 | 0x3F;
   	out[1] = 0xA0;
   	I2C_write_bytes(out, 2);

   	/* zerowanie bitu BDU(0x20) w rejestrze CTRL2(0x21) */
	out[0] = 0x00 | 0x21;
   	out[1] = 0x04;
   	I2C_write_bytes(out, 2);

}

