/*
 * Crash Course STM32C0
 * Elektronika Praktyczna
 *
 * Przyklad 8. Komunikacja przez I2C + NVIC + EXTI
 * plik main.c
 *
 */

#include "stm32c031xx.h"
#include "hardware.h"
#include "utils.h"
#include "lis2dw12_driver.h"


volatile uint8_t drdy_flag;

int main()
{

    GPIO_config();
    RCC_configClockSource();
    UART_config();
    I2C_config(0x30);

    LIS2DW12_I2C_startup();
    LIS2DW12_I2C_enable_DRDY_INT1();

    EXTI_config();
    NVIC_Config();

    while(1)
    {

    	if(drdy_flag)
    	{
    		drdy_flag = 0;

    		int16_t x, y, z;
    		char delim[] = ",";
    		char eol[] = "\n";

    		LIS2DW12_I2C_read_XYZ(&x, &y, &z);
    		UART_print_num(x);
    		UART_print_chars(delim);

    		UART_print_num(y);
    		UART_print_chars(delim);

    		UART_print_num(z);
    		UART_print_chars(eol);
    	}

    }
}
